const Player = require("cattura-player-core");

function initPlayer (options)
{
    let container = document.getElementById("playerContainer");
    return new Player({
        container: container,
        manifestUri: options.root + "live/dash/" + options.streamId + ".mpd",
        autoplay: true,
        reconnect: true,
        pollManifestIntervalSec: options.pollManifestIntervalSec,
        events: {
            load: () => container.classList.remove("loading")
        }
    });
}

window.initPlayer = initPlayer;
