(function(f){if(typeof exports==="object"&&typeof module!=="undefined"){module.exports=f()}else if(typeof define==="function"&&define.amd){define([],f)}else{var g;if(typeof window!=="undefined"){g=window}else if(typeof global!=="undefined"){g=global}else if(typeof self!=="undefined"){g=self}else{g=this}g.livePreviewPluginExtension = f()}})(function(){var define,module,exports;return (function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){

},{}],2:[function(require,module,exports){
const _      = require("lodash");
const ko     = require("knockout");
const toastr = require("toastr");

const PreviewCache = require("./previewCache");

const PreviewRecording = require("./preview-recording");

const AUDIO_ONLY_PREVIEW = {
    default: "image",
    streams: {
        image: {
            thumbnailUri: "img/audio-only.png",
            imageUri: "img/audio-only-preview.png",
            title: ""
        }
    }
};

const PREVIEWABLE_STATES = ["CAPTURING", "PAUSED"];

function LivePreviewExtension (plugin)
{
    const {apiv1, apiv2} = require("./api");
    
    const previewCache = new PreviewCache({
        apiv1: apiv1
    });
    plugin.getPreviewForSession = previewCache.getPreviewForSession;
    
    const previewStream = require("./preview-stream")();
    plugin.canPreviewDevice = function canPreviewDevice ()
    {
        const {isCapturing} = require("./dashboard");
        const {isDetecting} = require("./settings").tabs.devices;
        return !(isCapturing() || isDetecting());
    };
    
    plugin.previewDevice = function previewDevice (device)
    {
        if (!plugin.canPreviewDevice())
        {
            return;
        }
        
        previewStream.open({
            title:      device.humanFriendlyName(),
            player:     `live/${device.sanitizedID}`,
            audioLevel: device.audioLevel,
            hasAudio:   device.hasAudio,
            hasVideo:   device.hasVideo
        });
    };
    
    plugin.previewRecording = function previewRecording (options)
    {
        const session = options.session;
        const captureRequest = options.captureRequest;
        const audioLevels = options.audioLevels;
        
        if (!session || !captureRequest || !_(PREVIEWABLE_STATES).includes(session.state))
        {
            return "";
        }
        
        const previewer = new PreviewRecording({
            apiv2:                 apiv2,
            previewCache:          previewCache,
            session:               session,
            captureRequest:        captureRequest,
            audioLevels:           audioLevels,
            onSessionStatusUpdate: message => toastr.success(message)
        });
        const rendered = $(previewer.render())[0];
        ko.applyBindings(previewer, rendered);
        
        previewCache.getPreviewForSession(captureRequest).then(preview => {
            preview = preview.thumbnail;
            if (!_(preview.streams).isEmpty())
            {
                previewer.preview(preview);
            }
            else
            {
                previewer.preview(AUDIO_ONLY_PREVIEW);
            }
        });
        
        return rendered;
    };
    
    return plugin;
}

module.exports = LivePreviewExtension;
},{"./api":undefined,"./dashboard":undefined,"./preview-recording":4,"./preview-stream":6,"./previewCache":7,"./settings":undefined,"knockout":"knockout","lodash":"lodash","toastr":undefined}],3:[function(require,module,exports){
var pug = require('pug-runtime');
module.exports=template;function pug_rethrow(n,e,r,t){if(!(n instanceof Error))throw n;if(!("undefined"==typeof window&&e||t))throw n.message+=" on line "+r,n;try{t=t||require("fs").readFileSync(e,"utf8")}catch(e){pug_rethrow(n,null,r)}var i=3,a=t.split("\n"),o=Math.max(r-i,0),h=Math.min(a.length,r+i),i=a.slice(o,h).map(function(n,e){var t=e+o+1;return(t==r?"  > ":"    ")+t+"| "+n}).join("\n");throw n.path=e,n.message=(e||"Pug")+":"+r+"\n"+i+"\n\n"+n.message,n}function template(locals) {var pug_html = "", pug_mixins = {}, pug_interp;
var pug_indent = [];

pug_html = pug_html + "\n\u003Cdiv class=\"player-container recording-live-preview\"\u003E";

pug_html = pug_html + "\n  \u003C!-- ko if: $data.preview && $data.preview()--\u003E";

pug_html = pug_html + "\n  \u003Cdiv class=\"player\" data-bind=\"livePreviewPlayer: {\n        headingText: captureRequest().title,\n        subheadingText: captureRequest().template().title,\n        livePreview: $data.preview(),\n        selectedSource: selectedSource,\n        audioLevel: audioLevelForSelectedSource,\n        elapsedTime: elapsedTime,\n        updateIntervalSec: 0,\n        switcherRefreshIntervalSec: 1\n    }\"\u003E\u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n  \u003C!-- \u002Fko--\u003E";

pug_html = pug_html + "\n  \u003Cbutton class=\"preview-button\" data-bind=\"visible: !isPreviewLive(), click: startLivePreview\"\u003E";

pug_html = pug_html + "\u003Cspan class=\"icon-play\"\u003E\u003C\u002Fspan\u003E";

pug_html = pug_html + "Live Preview\u003C\u002Fbutton\u003E";

pug_html = pug_html + "\n  \u003Cbutton class=\"preview-button\" data-bind=\"visible: isPreviewLive, click: stopLivePreview\"\u003E";

pug_html = pug_html + "\u003Cspan class=\"icon-play\"\u003E\u003C\u002Fspan\u003E";

pug_html = pug_html + "Thumbnail View\u003C\u002Fbutton\u003E";

pug_html = pug_html + "\n  \u003Cbutton class=\"pause-button\" data-bind=\"visible: !session().paused, click: pause\"\u003E";

pug_html = pug_html + "\u003Cspan class=\"icon-pause\"\u003E\u003C\u002Fspan\u003E";

pug_html = pug_html + "Pause\u003C\u002Fbutton\u003E";

pug_html = pug_html + "\n  \u003Cbutton class=\"resume-button\" data-bind=\"visible: session().paused, click: resume\"\u003E";

pug_html = pug_html + "\u003Cspan class=\"icon-resume\"\u003E\u003C\u002Fspan\u003E";

pug_html = pug_html + "Resume\u003C\u002Fbutton\u003E";

pug_html = pug_html + "\n  \u003Cbutton class=\"stop-button\" data-bind=\"click: stop\"\u003E";

pug_html = pug_html + "\u003Cspan class=\"icon-stop\"\u003E\u003C\u002Fspan\u003E";

pug_html = pug_html + "Stop\u003C\u002Fbutton\u003E\n\u003C\u002Fdiv\u003E";return pug_html;}

},{"fs":1,"pug-runtime":"pug-runtime"}],4:[function(require,module,exports){
const ko     = require("knockout");
const _      = require("lodash");
const moment = require("moment");

const {observableAdapter} = require("cattura-ui-library/src/lib/knockoutUtils");

const template = require("./content.pug");

const URI_PROPERTIES = ["imageUri", "player", "staticImageUri", "thumbnailUri", "dashManifestUri"];
const DEFAULT_OPTIONS = {
    onSessionStatusUpdate: _.noop,
    onSessionPause:        _.noop,
    onSessionResume:       _.noop,
    onSessionStop:         _.noop,
    baseUri:               ""
};

function PreviewRecording (options)
{
    if (!(this instanceof PreviewRecording))
    {
        return new PreviewRecording(options);
    }
    
    options = _({})
        .extend(DEFAULT_OPTIONS)
        .extend(options)
        .value();
    
    const apiv2                 = options.apiv2;
    const previewCache          = options.previewCache;
    const onSessionStatusUpdate = (callback => ((message, retval) => {
        if (ko.isWritableObservable(session))
        {
            session(retval.session);
        }
        
        return callback(message, retval);
    }))(options.onSessionStatusUpdate);
    const onSessionPause        = options.onSessionPause;
    const onSessionResume       = options.onSessionResume;
    const onSessionStop         = options.onSessionStop;
    const baseUri               = options.baseUri;
    
    let isPreviewLive  = ko.observable(options.isPreviewLive);
    this.isPreviewLive = isPreviewLive;
    
    let preview = observableAdapter(ko.observable(), {
        readAdapter (value)
        {
            if (!value || !baseUri)
            {
                return value;
            }
            
            return _({}).extend(value).extend({
                streams: _(value.streams).mapValues(stream => {
                    return _(stream).mapValues((value, key) => {
                        return _(URI_PROPERTIES).includes(key) ? baseUri + value
                                                               : value;
                    }).value();
                }).value()
            }).value();
        }
    }, options.preview);
    this.preview = preview;
    
    let selectedSource  = ko.observable();
    this.selectedSource = selectedSource;
    
    let captureRequest  = ko.observable(options.captureRequest);
    this.captureRequest = captureRequest;
    
    let session  = ko.isObservable(options.session) ? options.session
                                                    : ko.observable(options.session);
    this.session = session;
    
    let audioLevels = ko.isObservable(options.audioLevels) ? options.audioLevels :
                                                             ko.observable(options.audioLevels);
    this.audioLevels = audioLevels;
    
    this.audioLevelForSelectedSource = ko.computed(() => {
        const audioLevels = this.audioLevels();
        if (typeof audioLevels !== "object")
        {
            return audioLevels;
        }

        return _(audioLevels).values().head();
    });
    this.elapsedTime = ko.computed(() => {
        const currentSession = session();
        if (!currentSession)
        {
            return -1;
        }
        
        return typeof currentSession.elapsedTime === "function" ? currentSession.elapsedTime()
                                                                : currentSession.elapsedTime;
    });
    
    this.stop = function stop ()
    {
        return apiv2.sessions.stopSession({
            id: captureRequest().mediaPackageID
        }).then(retval => {
            onSessionStatusUpdate(`Recording ${captureRequest().title} stopped successfully.`, retval);
            onSessionStop(retval);
        });
    };

    this.pause = function pause ()
    {
        return apiv2.sessions.pauseSession({
            id: captureRequest().mediaPackageID
        }).then(retval => {
            onSessionStatusUpdate(`Recording ${captureRequest().title} paused successfully.`, retval);
            onSessionPause(retval);
        });
    };

    this.resume = function resume ()
    {
        return apiv2.sessions.resumeSession({
            id: captureRequest().mediaPackageID
        }).then(retval => {
            onSessionStatusUpdate(`Recording ${captureRequest().title} resumed successfully.`, retval);
            onSessionResume(retval);
        });
    };

    this.startLivePreview = function startLivePreview ()
    {
        previewCache.getPreviewForSession(captureRequest()).then(preview => {
            this.preview(preview.live);
            isPreviewLive(true);
        });
    };

    this.stopLivePreview = function stopLivePreview ()
    {
        previewCache.getPreviewForSession(captureRequest()).then(preview => {
            this.preview(preview.thumbnail);
            isPreviewLive(false);
        });
    };
    
    this.startThumbnailPreview = this.stopLivePreview;
    this.render = template;
}

module.exports = PreviewRecording;
},{"./content.pug":3,"cattura-ui-library/src/lib/knockoutUtils":8,"knockout":"knockout","lodash":"lodash","moment":"moment"}],5:[function(require,module,exports){
var pug = require('pug-runtime');
module.exports=template;function pug_rethrow(n,e,r,t){if(!(n instanceof Error))throw n;if(!("undefined"==typeof window&&e||t))throw n.message+=" on line "+r,n;try{t=t||require("fs").readFileSync(e,"utf8")}catch(e){pug_rethrow(n,null,r)}var i=3,a=t.split("\n"),o=Math.max(r-i,0),h=Math.min(a.length,r+i),i=a.slice(o,h).map(function(n,e){var t=e+o+1;return(t==r?"  > ":"    ")+t+"| "+n}).join("\n");throw n.path=e,n.message=(e||"Pug")+":"+r+"\n"+i+"\n\n"+n.message,n}function template(locals) {var pug_html = "", pug_mixins = {}, pug_interp;
var pug_indent = [];

pug_html = pug_html + "\n\u003Cdiv class=\"preview-stream\" data-bind=\"dialog: $root\"\u003E";

pug_html = pug_html + "\n  \u003Cdiv class=\"inner-dialog\" data-bind=\"with: stream, css: { 'has-audio': stream() &amp;&amp; stream().hasAudio, 'has-video': stream() &amp;&amp; stream().hasVideo }\"\u003E";

pug_html = pug_html + "\n    \u003Ch2 class=\"heading\" data-bind=\"text: title\"\u003E\u003C\u002Fh2\u003E";

pug_html = pug_html + "\n    \u003Cdiv class=\"close icon-close-white\" data-bind=\"click: $parent.close\"\u003E\u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n    \u003Cdiv data-bind=\"extendUI: { type: 'settings.devices.preview', device: $data }\"\u003E";

pug_html = pug_html + "\n      \u003Ciframe class=\"video\" data-bind=\"attr: { src: player }\"\u003E\u003C\u002Fiframe\u003E";

pug_html = pug_html + "\n      \u003Cdiv data-bind=\"if: 'audioLevel' in $data\"\u003E";

pug_html = pug_html + "\n        \u003Cdiv class=\"audio\" data-bind=\"audioLevelMeter: { value: audioLevel }\"\u003E\u003C\u002Fdiv\u003E\n      \u003C\u002Fdiv\u003E\n    \u003C\u002Fdiv\u003E\n  \u003C\u002Fdiv\u003E\n\u003C\u002Fdiv\u003E";return pug_html;}

},{"fs":1,"pug-runtime":"pug-runtime"}],6:[function(require,module,exports){
const _ = require("lodash");
const ko = require("knockout");

const Dialog = require("cattura-ui-library/src/lib/ui/dialog");

function makeDialog ()
{
    let currentStream = ko.observable();

    return Dialog({
        open (stream)
        {
            currentStream(stream);
            this.show();
        },

        close ()
        {
            currentStream(null);
            this.hide();
        },

        stream: currentStream
    }, {
        template: require("./content.pug")
    });
}

module.exports = makeDialog;

},{"./content.pug":5,"cattura-ui-library/src/lib/ui/dialog":"cattura-ui-library/src/lib/ui/dialog","knockout":"knockout","lodash":"lodash"}],7:[function(require,module,exports){
const _ = require("lodash");

function PreviewCache (options)
{
    const apiv1 = options.apiv1;
    
    let cachedPreviews = {};

    function makeThumbnailOnlyPreview (preview)
    {
        return _({}).extend(preview).extend({
            streams: _(preview.streams).mapValues(stream => {
                return {
                    title: stream.title,
                    thumbnailUri: stream.thumbnailUri,
                    imageUri: stream.imageUri || stream.staticImageUri
                };
            }).value()
        }).value();
    }

    function getPreviewForSession (session)
    {
        let sessionId = session;
        if (typeof sessionId === "object")
        {
            if (sessionId.captureRequest)
            {
                sessionId = sessionId.captureRequest;
            }

            if (sessionId.mediaPackageID)
            {
                sessionId = sessionId.mediaPackageID;
            }
        }

        if (!sessionId)
        {
            return null;
        }

        if (!(sessionId in cachedPreviews))
        {
            cachedPreviews[sessionId] = cachedPreviews[sessionId] = apiv1.liveStreamViewer.getPreviewForSession({
                id: sessionId
            }).then(preview => {
                return {
                    live: preview,
                    thumbnail: makeThumbnailOnlyPreview(preview)
                };
            }).catch(() => delete cachedPreviews[sessionId]);
        }

        return cachedPreviews[sessionId];
    }
    
    this.getPreviewForSession = getPreviewForSession;
}

module.exports = PreviewCache;
},{"lodash":"lodash"}],8:[function(require,module,exports){
const _ = require("lodash");
const ko = require("knockout");

function sortedObservableArray (innerArray, sorter)
{
    return ko.computed({
        read () {
            return innerArray();
        },
        write (value) {
            innerArray(_(value).sortBy(sorter).value());
        }
    });
}

function makeConfigObservable (values, options)
{
    options = _({
        memberResolver: _.identity,
        valuesResolver: _.identity
    }).extend(options).value();

    let observable = _(ko.computed({
        read ()
        {
            return _(options.valuesResolver(values)).toPairs().map(pair => {
                const key = pair[0];
                return [key, options.memberResolver(pair[1], key)()];
            }).fromPairs().value();
        },

        write (newValues)
        {
            _(options.valuesResolver(values)).each((value, key) => options.memberResolver(value, key)(typeof newValues === "object" ? newValues[key] : undefined));
        }
    })).extend(values).value();

    const validator = "validatedObservable" in ko ? ko.validatedObservable(values)
                                                  : null;
    
    observable.isValid = function isValid ()
    {
        return validator ? validator.isValid() : true;
    };

    return observable;
}

function observableAdapter (observable, options, value)
{
    options = _({
        readAdapter (values) {return values;},
        writeAdapter (values) {return values;},
    }).extend(options).value();
    
    let computed = ko.computed({
        read ()
        {
            return options.readAdapter(observable());
        },
        
        write (value)
        {
            observable(options.writeAdapter(value));
        }
    });

    _(observable).pickBy(ko.isObservable)
        .each((value, key) => computed[key] = observableAdapter(value));

    if ("isValid" in observable)
    {
        computed.isValid = () => observable.isValid();
    }    

    if (typeof value !== "undefined")
    {
        computed(value);
    }

    return computed;
}

function chainedObservable (observables, iteratee, accumulator)
{
    let observableArray = ko.observableArray();
    let computed = ko.computed(() => _(observableArray())
        .map(observable => observable())
        .reduce(iteratee, accumulator));
    
    computed.append = function append (observable)
    {
        if (!ko.isObservable(observable))
        {
            if (typeof observable === "function")
            {
                observable = ko.computed(observable);
            }
            else
            {
                observable = ko.observable(observable);
            }
        }
        
        observableArray.push(observable);
    };
    
    _(observables).forEach(observable => computed.append(observable));
    return computed;
}

function settingsObservable (value)
{
    let settings = ko.observable(value || {});
    settings.getOrDefault = function getOrDefault (key, defaultValue)
    {
        const value = settings()[key];
        return typeof value !== "undefined" ? value : defaultValue;
    };

    settings.getBoolean = function getBoolean (key, defaultValue)
    {
        const value = settings.getOrDefault(key, defaultValue);
        if (typeof value === "undefined")
        {
            return;
        }

        return typeof value === "string" ? value == "true" : !!value;
    };
    
    return settings;
}

function objectPropertyObservable (object, property)
{
    return ko.computed({
        write (value)
        {
            _(ko.unwrap(object)).set(property, value).value();
        },
        
        read ()
        {
            return _(ko.unwrap(object)).get(property);
        }
    });
}

function extendDefaultKnockoutBindingContext (extender)
{
    ko.applyBindings = (ab => function applyBindings (viewModel, element) {
        return ab.call(ko, viewModel, element || document.documentElement, extender);
    })(ko.applyBindings);
    return ko;
}

module.exports = {
    sortedObservableArray: sortedObservableArray,
    makeConfigObservable: makeConfigObservable,
    observableAdapter: observableAdapter,
    chainedObservable: chainedObservable,
    settingsObservable: settingsObservable,
    objectPropertyObservable: objectPropertyObservable,
    extendDefaultKnockoutBindingContext: extendDefaultKnockoutBindingContext
};
},{"knockout":"knockout","lodash":"lodash"}]},{},[2])(2)
});
